#include <graphics.h>
#include <alloc.h>

#include "standard.h"
#include "i_lib.h"

void RUBBER_move_area( tx,ty,bx,by,btx,bty,bbx,bby )

int *tx,*ty,*bx,*by;     /* location of the area */
int btx,bty,bbx,bby;     /* bounds of the area */

begin

    int x,y,dx,dy;
    int nx,ny;
    I_input_t new_input;
    int width,height;

    /* determine the offsets for the x and y values from the position */
    /* of the mouse */

    MOUSE_hide_cursor();
    MOUSE_set_position( *tx,*ty );

    /* set the height and the width */

    width = *bx - *tx;
    height = *by - *ty;

    /* Determine the style of rubberband box to use: Solid lines and XOR on */
    /* the screen. */

    setviewport(0,0,getmaxx(),getmaxy(),TRUE);
    setwritemode(XOR_PUT);
    setlinestyle(SOLID_LINE,0,NORM_WIDTH);
    setcolor(WHITE);

    /* loop through all the mouse input commands until the button is */
    /* released */

    MOUSE_set_bounds(btx,bty,bbx-width,bby-height);
    rectangle( *tx,*ty,*tx+width,*ty+height );

    do begin

       /* draw the rubber band box and*/
       /* get the current input from the Y_INPUT module */

       MOUSE_trash_events();
       I_get( &new_input );

       /* if the user has moved the mouse then calculate the change in the */
       /* box's position */

       if (new_input.func==I_MMOVE)
         begin

           nx = new_input.x;
           ny = new_input.y;

           /* make sure it is a legal move */

           if (!((*tx==nx) AND (*ty==ny)))
             begin
               rectangle( *tx,*ty,*tx+width,*ty+height );
               *tx = nx;
               *ty = ny;
               rectangle( *tx,*ty,*tx+width,*ty+height );
             end

         end

    end while ((new_input.func!=I_MPUSH_L) AND (new_input.func!=I_MCLICK_L));

    /* fix the line parameters to normal */

    rectangle( *tx,*ty,*tx+width,*ty+height );
    setwritemode(COPY_PUT);
    MOUSE_set_bounds(0,0,getmaxx(),getmaxy());
    MOUSE_display_cursor();
    
    *bx = *tx + width;
    *by = *ty + height;

end



main()

begin

    int driver,mode;
    int tx,ty,bx,by;

    registerbgidriver(EGAVGA_driver);
    detectgraph(&driver,&mode);

    /* check all the possible graphics drivers and set the mode */
    /* accordingly */

    switch( driver )
     begin

       case EGA :      mode = EGAHI;       break;
       case EGA64 :    mode = EGA64HI;     break;
       case EGAMONO :  mode = EGAMONOHI;   break;
       case VGA :      mode = VGAMED;       break;

       default : printf("This example requires EGA/VGA card.\n\n");
                 exit();

     end

   /* now that we have determined the mode, set the graphics to that */
   /* mode and check the status */

   initgraph(&driver,&mode,NULL);
   if (graphresult()!=grOk)
     begin
        printf("Unable to find the BGI files\n\n");
        exit();
     end

   /* initialize the mouse driver */

   MOUSE_initialize();

   tx = getmaxx()/3;
   ty = getmaxy()/3;
   bx = 2*getmaxx()/3;
   by = 2*getmaxy()/3;
   RUBBER_move_area(&tx,&ty,&bx,&by,20,20,getmaxx()-20,getmaxy()-20);

   MOUSE_shutdown();
   restorecrtmode();

end
